import { useAjax } from "@/Hook/useAjax"
import { getAdAccountAllOfMember } from "@/services/launchAdq/adq"
import { IdcardFilled } from "@ant-design/icons"
import { Menu, Select, Spin } from "antd"
import React, { useEffect, useState } from "react"
import { useModel } from "umi"
import './index.less'

interface Props {
    onChange?: (id?: number) => void
    value?: number
}
/**
 * 选择组员左菜单
 */
const TeamMembers: React.FC<Props> = (props) => {

    /*************************/
    const { onChange, value } = props
    const [userAll, setUserAll] = useState([])

    const userInfo = useModel('@@initialState', model => model.initialState?.currentUser)
    const [userId, setUserId] = useState<any>(userInfo?.userId?.toString())
    const allOfMember = useAjax(() => getAdAccountAllOfMember(), { formatResult: true })
    /*************************/


    useEffect(() => {
        onChange?.(userId)
    }, [userId])

    useEffect(() => {
        if (value) {
            setUserId(value.toString())
        }
    }, [value])

    /** 获取组员 */
    useEffect(() => {
        (async function () {
            let res = allOfMember?.data || await allOfMember.run()
            if (res?.data) {
                let useAll: any = []
                res?.data?.forEach((item: { key: { userId: any; nickName: any; }; value: any[]; }) => {
                    let obj = {
                        key: item.key.userId,
                        label: item.key.nickName,
                        icon: <IdcardFilled />,
                    }
                    if (item?.value) {
                        obj['childrenarr'] = item?.value?.map(item => {
                            return { key: item.accountId + '_' + item.id, label: item?.remark ? item.accountId + '_' + item?.remark : item.accountId }
                        })
                    }
                    useAll.push(obj)
                })
                setUserAll(useAll)
            }
        })()

    }, [])

    useEffect(() => {

    }, [])
    console.log('allOfMember--->', allOfMember);


    /** 初始跳转到自己的名称 */
    useEffect(() => {
        if (userAll?.length > 0 && userId) {
            let topEq = userAll?.findIndex((item: any) => item.key == userId)
            let em: any = document.getElementById('myMenus')
            if (em) em.scrollTop = (52 - 4) * topEq
        }
    }, [userId, userAll])

    return <div className="teamMembers">
        <Select
            placeholder='名称搜索'
            style={{ width: '100%' }}
            showSearch
            filterOption={(input: any, option: any) => {
                return (option!?.children as unknown as string)?.toLowerCase()?.includes(input?.toLowerCase())
            }}
            loading={allOfMember.loading}
            allowClear
            onChange={(value: any) => {
                if (value) {
                    setUserId(value.toString())
                }
            }}
        >
            {userAll.map((item: any) => {
                return <Select.Option value={item.key} key={item.key}>{item.label}</Select.Option>
            })}
        </Select>
        <Spin className="menus" spinning={allOfMember.loading}>
            <Menu
                id='myMenus'
                theme='light'
                onClick={(e: any) => {
                    setUserId(e.key)
                }}
                selectedKeys={userId}
                mode="inline"
                multiple={false}
                items={userAll}
                style={{
                    overflowY: 'auto',
                    height: 'calc(100vh - 190px)',
                    overflowX: 'hidden'
                }}
            />
        </Spin>

    </div>
}


export default React.memo(TeamMembers)